/*
 * 11/2008, Jimmy Eng
 * simple ms2 to dta converter
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SIZE_BUF 5000


void WRITE_DTA(FILE *fp,
      char *szDtaName,
      char *szMH,
      int iCharge)
{
   char szBuf[SIZE_BUF];
   FILE *fpout;

   if ( (fpout=fopen(szDtaName, "w"))!=NULL)
   {
      /*
       * write out first line of .dta file
       */
      fprintf(fpout, "%s %d\n", szMH, iCharge);

      /*
       * write out mz/int pairs
       */
      while (fgets(szBuf, SIZE_BUF, fp))
      {
         if (szBuf[0]=='S')
            break;
         else if (!isalpha(szBuf[0]))
            fprintf(fpout, "%s", szBuf);
      }
      fclose(fpout);
   }
   else
      printf(" skipping: %s (cannot write .dta file)\n", szDtaName);
}


int main(int argc, char *argv[])
{
   int i;

   if (argc<2)
   {
      printf("\n");
      printf(" USAGE: %s *.ms2\n\n", argv[0]);
      printf(" This program converts .ms2 files to individual .dta files\n");
      printf(" which are placed in separate subdirectories, one for each\n");
      printf(" input .ms2 file.\n");
      printf("\n");
   }

   /*
    * loop through all input files
    */
   for (i=1; i<argc; i++)
   {
      char szInput[SIZE_BUF];

      strcpy(szInput, argv[i]);

      /*
       * handle only files with .ms2 extension
       */
      if (!strncasecmp(szInput+strlen(szInput)-4, ".ms2", 4))
      {
         FILE *fp;

         if ((fp=fopen(szInput, "rb"))!=NULL)
         {
            char szBaseName[SIZE_BUF];
            char szBuf[SIZE_BUF];

            strcpy(szBaseName, szInput);
            szBaseName[strlen(szBaseName)-4]='\0';

            printf(" converting %s\n", szInput);

            /*
             * put .dta files in respective subdirectories
             */
            sprintf(szBuf, "mkdir %s", szBaseName);
            system(szBuf);

            szBuf[0]='\0';

            while (fgets(szBuf, SIZE_BUF, fp))
            {
               long lFilePos;

               /*
                * start of a new spectrum
                */
               if (szBuf[0]=='S')
               {
                  char szDtaName[SIZE_BUF];
                  int iStartScan=0;
                  int iEndScan=0;

                  /*
                   * grab start & end scan here
                   */
                  sscanf(szBuf, "%*s %d %d", &iStartScan, &iEndScan);

                  while (fgets(szBuf, SIZE_BUF, fp))
                  {
                     /*
                      * now grab all charge state lines, search until fragment ion lines
                      */
                     if (szBuf[0]=='Z')
                     {
                        int iCharge=0;
                        char szMH[50];
                        long lFilePos;

                        lFilePos=ftell(fp);
   
                        sscanf(szBuf, "%*s %d %s", &iCharge, szMH);
                        sprintf(szDtaName, "%s/%s.%0.5d.%0.5d.%d.dta", szBaseName, szBaseName, iStartScan, iEndScan, iCharge);
   
                        WRITE_DTA(fp, szDtaName, szMH, iCharge);

                        fseek(fp, lFilePos, SEEK_SET);
                     }
                     else if (isdigit(szBuf[0]))
                     {
                        break;
                     }
                  }
               }
            }
            fclose(fp);
         }
         else
            printf(" skipping: %s (cannot read)\n", szInput);
      }
      else
         printf(" skipping: %s\n", szInput);
   }
   return 0;
} 
